#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>
#include <unistd.h>
#ifndef __NT__
#include <sys/param.h>
#else
typedef unsigned short ushort;
typedef unsigned long ulong;
#define MAXPATHLEN 255
#endif

#include "qfaxparse.h"

#if defined (__386__) || defined(_i386_) 
#define LITTLE_ENDIAN
#endif

#ifdef LITTLE_ENDIAN
ushort swapword (ushort val)
{
    return (ushort) (val << 8) + (val >> 8);
}
ulong swaplong (ulong val)
{
    return (ulong) (((ulong) swapword (val & 0xFFFF) << 16) |
		    (ulong) swapword (val >> 16));
}

void HeaderEndianise(QFAXHEADER *h)
{
    h->title = swaplong(h->title);
    h->version = swaplong(h->version);
    h->width = swapword(h->width);
    h->page = swapword(h->page);
    h->pagemax = swapword(h->pagemax);
    h->stamp = swaplong(h->stamp);
    h->hint = swaplong(h->hint);
    h->offset = swaplong(h->offset);
}

void OffrecEndianise(OFFREC *o)
{
    o->off = swaplong(o->off);
    o->pageno = swapword(o->pageno);
    o->code = swapword(o->code);
    o->res = swapword(o->res);
}

FILE *lopen(const char *s, const char *mode)
{
    FILE *fp;
#ifdef __NT__
    char fnam[256];
#endif
    
    if(*s == '~')
    {
#ifndef __NT__
	char *p = (char *)alloca(MAXPATHLEN);
#else
        char *p = fnam;
#endif
	strcpy(p, getenv("HOME"));
	strcat(p, s + 1);
	s = p;
    }
    
    fp = fopen(s, mode);
    if(fp == NULL)
    {
	char pname[512];
	char *pf;
	
	if((pf = getenv("HOME")))
	{
	    short n;
	    
	    strcpy(pname, pf);
	    n = strlen(pname);
	    if(*(pname + n-1) != '/' 
#ifdef __NT__
                && *(pname + n-1) != '\\'
#endif
                )
	    {
		*(pname + n) = '/';
		*(pname + n+1) = '\0';
	    }
	    strcat(pname, s);
	    fp = fopen(pname, mode);
	}
    }
    return fp;
}
#endif
#ifdef __NT__
char *stpcpy(char *d, const char *s) 
{
    while(*d++ = *s++)
        ;
    return d-1;
}
#endif

#ifdef TEST
main(int ac, char **av)
{
    FILE *fp = lopen("~/.qfax.phone", "r");
    
    return 0;
}
#endif


